
class Imagenet100_64AutoAugmentMLPMixer8L1xWide00Dropout1e_4WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 1*128, 1*512, 1*64, nn.GELU, 0.0, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-4),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L1xWide00Dropout1e_3WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 1*128, 1*512, 1*64, nn.GELU, 0.0, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-3),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L1xWide00Dropout1e_2WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 1*128, 1*512, 1*64, nn.GELU, 0.0, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-2),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L1xWide01Dropout1e_4WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 1*128, 1*512, 1*64, nn.GELU, 0.1, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-4),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L1xWide01Dropout1e_3WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 1*128, 1*512, 1*64, nn.GELU, 0.1, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-3),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L1xWide01Dropout1e_2WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 1*128, 1*512, 1*64, nn.GELU, 0.1, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-2),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L2xWide00Dropout1e_4WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 2*128, 2*512, 2*64, nn.GELU, 0.0, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-4),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L2xWide00Dropout1e_3WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 2*128, 2*512, 2*64, nn.GELU, 0.0, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-3),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L2xWide00Dropout1e_2WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 2*128, 2*512, 2*64, nn.GELU, 0.0, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-2),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L2xWide01Dropout1e_4WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 2*128, 2*512, 2*64, nn.GELU, 0.1, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-4),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L2xWide01Dropout1e_3WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 2*128, 2*512, 2*64, nn.GELU, 0.1, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-3),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L2xWide01Dropout1e_2WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 2*128, 2*512, 2*64, nn.GELU, 0.1, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-2),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L4xWide00Dropout1e_4WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 4*128, 4*512, 4*64, nn.GELU, 0.0, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-4),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L4xWide00Dropout1e_3WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 4*128, 4*512, 4*64, nn.GELU, 0.0, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-3),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L4xWide00Dropout1e_2WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 4*128, 4*512, 4*64, nn.GELU, 0.0, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-2),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L4xWide01Dropout1e_4WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 4*128, 4*512, 4*64, nn.GELU, 0.1, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-4),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L4xWide01Dropout1e_3WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 4*128, 4*512, 4*64, nn.GELU, 0.1, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-3),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer8L4xWide01Dropout1e_2WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 4*128, 4*512, 4*64, nn.GELU, 0.1, 8)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-2),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L1xWide00Dropout1e_4WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 1*128, 1*512, 1*64, nn.GELU, 0.0, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-4),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L1xWide00Dropout1e_3WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 1*128, 1*512, 1*64, nn.GELU, 0.0, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-3),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L1xWide00Dropout1e_2WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 1*128, 1*512, 1*64, nn.GELU, 0.0, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-2),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L1xWide01Dropout1e_4WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 1*128, 1*512, 1*64, nn.GELU, 0.1, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-4),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L1xWide01Dropout1e_3WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 1*128, 1*512, 1*64, nn.GELU, 0.1, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-3),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L1xWide01Dropout1e_2WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 1*128, 1*512, 1*64, nn.GELU, 0.1, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-2),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L2xWide00Dropout1e_4WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 2*128, 2*512, 2*64, nn.GELU, 0.0, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-4),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L2xWide00Dropout1e_3WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 2*128, 2*512, 2*64, nn.GELU, 0.0, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-3),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L2xWide00Dropout1e_2WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 2*128, 2*512, 2*64, nn.GELU, 0.0, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-2),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L2xWide01Dropout1e_4WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 2*128, 2*512, 2*64, nn.GELU, 0.1, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-4),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L2xWide01Dropout1e_3WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 2*128, 2*512, 2*64, nn.GELU, 0.1, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-3),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L2xWide01Dropout1e_2WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 2*128, 2*512, 2*64, nn.GELU, 0.1, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-2),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L4xWide00Dropout1e_4WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 4*128, 4*512, 4*64, nn.GELU, 0.0, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-4),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L4xWide00Dropout1e_3WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 4*128, 4*512, 4*64, nn.GELU, 0.0, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-3),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L4xWide00Dropout1e_2WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 4*128, 4*512, 4*64, nn.GELU, 0.0, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-2),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L4xWide01Dropout1e_4WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 4*128, 4*512, 4*64, nn.GELU, 0.1, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-4),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L4xWide01Dropout1e_3WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 4*128, 4*512, 4*64, nn.GELU, 0.1, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-3),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )


class Imagenet100_64AutoAugmentMLPMixer12L4xWide01Dropout1e_2WDAdamLinearWarmupDecayTask(AbstractTask):
    def get_dataset_params(self):
        return get_imagenet100_64_params(
            train_transforms=get_resize_crop_flip_autoaugment_transforms(64, 8, torchvision.transforms.AutoAugmentPolicy.IMAGENET)
        )
    
    def get_model_params(self):
        return get_basic_mlp_mixer_params([3,64,64], 100, 8, 4*128, 4*512, 4*64, nn.GELU, 0.1, 12)
    
    def get_experiment_params(self) -> BaseExperimentConfig:
        return get_adv_experiment_params(
            MixedPrecisionAdversarialTrainer,
            get_common_training_params(),
            get_common_adversarial_params(),
            AdamOptimizerConfig(weight_decay=1e-2),
            CyclicLRConfig(base_lr=1e-6, max_lr=0.001, step_size_up=250*30, step_size_down=250*270, cycle_momentum=False),
            512
        )

